/**
 * 
 */
package com.rjconsultores.ventaboletos.relatorios.impl;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Timestamp;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

import com.rjconsultores.ventaboletos.relatorios.utilitarios.ArrayDataSource;
import com.rjconsultores.ventaboletos.relatorios.utilitarios.IndStatusBoleto;
import com.rjconsultores.ventaboletos.relatorios.utilitarios.Relatorio;
import com.rjconsultores.ventaboletos.utilerias.DateUtil;
import com.rjconsultores.ventaboletos.web.utilerias.NamedParameterStatement;

/**
 * @author Thiago
 *
 */
public class RelatorioBilhetesVendidos extends Relatorio {


	public RelatorioBilhetesVendidos(Map<String, Object> parametros, Connection conexao) throws Exception {
		super(parametros, conexao);

		this.setCustomDataSource(new ArrayDataSource(this) {
			@Override
			public void initDados() throws Exception {

				Connection conexao = this.relatorio.getConexao();
				Map<String, Object> parametros = this.relatorio.getParametros();

				StringBuilder sql = new StringBuilder();

				sql.append(" select ");
				sql.append(" B.TIPOVENTA_ID IMPRESSAO_POSTERIOR, ");
				sql.append(" B.NUMFOLIOSISTEMA NUMERO_PASSAGEM, ");
				sql.append(" B.NUMSERIEPREIMPRESA SERIE, ");
				sql.append(" B.NUMSERIEPREIMPRESA SUB_SERIE, ");
                sql.append(" B.NUMFOLIOPREIMPRESO PRE_IMPRESSO, ");
                sql.append(" p_origen.PARADA_ID COD_ORIGEM, ");
                sql.append(" p_origen.DESCPARADA ORIGEM, ");
                sql.append(" p_destino.PARADA_ID COD_DESTINO, ");
                sql.append(" p_destino.DESCPARADA DESTINO, ");
                sql.append(" pv.NUMPUNTOVENTA COD_AGENCIA, ");
                sql.append(" pv.NOMBPUNTOVENTA NOME_AGENCIA, ");
                sql.append(" B.FECHORVENTA DATA, ");
                sql.append(" B.fechorviaje DATA_VIAGEM, ");
                sql.append(" B.CORRIDA_ID SERVICO, ");
                sql.append(" to_char(B.fechorviaje, 'hh24:mi:ss') HORA, ");
                sql.append(" B.NUMASIENTO NUMASIENTO, ");
                sql.append(" ct.DESCCATEGORIA CATEGORIA, ");
                sql.append(" R.INDSENTIDOIDA SENTIDO, ");
                sql.append(" R.NUMRUTA COD_LINHA, ");
                sql.append(" R.DESCRUTA DESC_LINHA, ");
                sql.append(" B.INDSTATUSBOLETO STATUS_PASSAGEM, ");
                sql.append(" B.PRECIOPAGADO TARIFA, ");
                sql.append(" B.IMPORTETAXAEMBARQUE TX_EMBARQUE, ");
                sql.append(" B.IMPORTEPEDAGIO PEDAGIO, ");
                sql.append(" B.IMPORTESEGURO SEGURO ");
				
				sql.append(" FROM BOLETO B ");
				sql.append(" JOIN RUTA R ON R.RUTA_ID = B.RUTA_ID ");
				sql.append(" JOIN PUNTO_VENTA pv on B.PUNTOVENTA_ID = pv.PUNTOVENTA_ID ");
				sql.append(" JOIN USUARIO u on u.USUARIO_ID = B.USUARIO_ID ");
				sql.append(" JOIN PARADA p_origen on p_origen.PARADA_ID = B.ORIGEN_ID ");
				sql.append(" JOIN PARADA p_destino on p_destino.PARADA_ID = B.DESTINO_ID ");
				sql.append(" JOIN CATEGORIA ct on ct.CATEGORIA_ID = B.CATEGORIA_ID ");
				sql.append(" JOIN CLASE_SERVICIO cs on cs.CLASESERVICIO_ID = B.CLASESERVICIO_ID ");
				sql.append(" JOIN MARCA m on m.marca_id = b.marca_id ");
				sql.append(" left join ciudad co ON co.ciudad_id = p_origen.ciudad_id ");
				sql.append(" left join estado est ON est.estado_id = co.estado_id ");
				sql.append(" WHERE ");
				sql.append(" m.EMPRESA_ID = :EMPRESA_ID ");
				sql.append(" and B.FECHORVENTA >= :DATA_INICIAL ");
				sql.append(" and B.FECHORVENTA <= :DATA_FINAL ");
				if (parametros.get("NUMPUNTOVENTA") != null && !parametros.get("NUMPUNTOVENTA").equals("-1")) {
					sql.append(" and pv.PUNTOVENTA_ID IN (" + parametros.get("NUMPUNTOVENTA").toString() + ")");
				}
				if (parametros.get("ESTADO_ID") != null && !parametros.get("ESTADO_ID").equals("-1")) {
					sql.append(" and est.estado_id = " + parametros.get("ESTADO_ID").toString() + "");
				}
				if (parametros.get("STATUS") != null) {
					if (parametros.get("STATUS").toString().contains("V") && parametros.get("STATUS").toString().contains("C")) {
						sql.append(" AND ((b.INDSTATUSBOLETO   = 'C' AND B.MOTIVOCANCELACION_ID IS NOT NULL) OR (b.INDSTATUSBOLETO = 'V' AND B.MOTIVOCANCELACION_ID IS NULL)) ");
					} else if (parametros.get("STATUS").toString().contains("C")) {
						sql.append(" AND b.INDSTATUSBOLETO   = 'C' AND B.MOTIVOCANCELACION_ID IS NOT NULL");
					} else if (parametros.get("STATUS").toString().contains("V")) {
						sql.append(" AND b.INDSTATUSBOLETO   = 'V' AND B.MOTIVOCANCELACION_ID IS NULL");
					}
				}
				sql.append(" and B.ACTIVO = 1 ");
				sql.append(" order by u.CVEUSUARIO, ");
				sql.append(" u.NOMBUSUARIO, ");
				sql.append(" pv.NUMPUNTOVENTA, ");
				sql.append(" pv.NOMBPUNTOVENTA, ");
				sql.append(" B.NUMFOLIOSISTEMA, ");
				sql.append(" p_origen.DESCPARADA, ");
				sql.append(" p_destino.DESCPARADA, ");
				sql.append(" ct.DESCCATEGORIA, ");
				sql.append(" B.INDSTATUSBOLETO, ");
				sql.append(" B.FECCORRIDA, ");
				sql.append(" B.CORRIDA_ID ");
 
				NamedParameterStatement stmt = new NamedParameterStatement(conexao, sql.toString());

				stmt.setInt("EMPRESA_ID", Integer.valueOf(parametros.get("EMPRESA_ID").toString()));
				stmt.setTimestamp("DATA_INICIAL", new Timestamp(DateUtil.inicioFecha((Date) parametros.get("DATA_INICIAL")).getTime()));
				stmt.setTimestamp("DATA_FINAL", new Timestamp(DateUtil.fimFecha((Date) parametros.get("DATA_FINAL")).getTime()));

				ResultSet rset = stmt.executeQuery();

				while (rset.next()) {

					Map<String, Object> dataResult = new HashMap<String, Object>();

					dataResult.put("NUMERO_PASSAGEM", rset.getString("NUMERO_PASSAGEM"));
					if (rset.getString("SERIE") != null) {
						if (rset.getString("SERIE").split("-").length == 1) {
							dataResult.put("SERIE", rset.getString("SERIE"));
						} else {
							dataResult.put("SERIE", rset.getString("SERIE").split("-")[0]);
							dataResult.put("SUB_SERIE", rset.getString("SERIE").split("-")[1]);
						}
					}
					dataResult.put("IMPRESSAO_POSTERIOR", rset.getInt("IMPRESSAO_POSTERIOR"));
					dataResult.put("PRE_IMPRESSO", rset.getString("PRE_IMPRESSO"));
					dataResult.put("COD_ORIGEM", rset.getString("COD_ORIGEM"));
					dataResult.put("ORIGEM", rset.getString("ORIGEM"));
					dataResult.put("COD_DESTINO", rset.getString("COD_DESTINO"));
					dataResult.put("DESTINO", rset.getString("DESTINO"));
					dataResult.put("NOME_AGENCIA", rset.getString("NOME_AGENCIA"));
					dataResult.put("COD_AGENCIA", rset.getString("COD_AGENCIA"));
					dataResult.put("DATA", rset.getDate("DATA"));
					dataResult.put("DATA_VIAGEM", rset.getDate("DATA_VIAGEM"));
					dataResult.put("SERVICO", rset.getString("SERVICO"));
					dataResult.put("HORA", rset.getString("HORA"));
					dataResult.put("NUMASIENTO", rset.getString("NUMASIENTO"));
					dataResult.put("CATEGORIA", rset.getString("CATEGORIA"));
					dataResult.put("SENTIDO", rset.getInt("SENTIDO"));
					dataResult.put("COD_LINHA", rset.getString("COD_LINHA"));
					dataResult.put("DESC_LINHA", rset.getString("DESC_LINHA"));
					if (rset.getString("STATUS_PASSAGEM") != null) {
						dataResult.put("STATUS_PASSAGEM", IndStatusBoleto.valueOf(rset.getString("STATUS_PASSAGEM")).getValue());
					}
					dataResult.put("TARIFA", rset.getString("TARIFA"));
					dataResult.put("TX_EMBARQUE", rset.getString("TX_EMBARQUE"));
					dataResult.put("PEDAGIO", rset.getString("PEDAGIO"));
					dataResult.put("SEGURO", rset.getString("SEGURO"));

					this.dados.add(dataResult);

				}

				this.resultSet = rset;
			}
		});
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see com.rjconsultores.ventaboletos.relatorios.utilitarios.Relatorio#processaParametros()
	 */
	@Override
	protected void processaParametros() throws Exception {

	}

}
