/**
 * 
 */
package com.rjconsultores.ventaboletos.relatorios.impl;

import java.math.RoundingMode;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Timestamp;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.rjconsultores.ventaboletos.relatorios.utilitarios.ArrayDataSource;
import com.rjconsultores.ventaboletos.relatorios.utilitarios.IndStatusBoleto;
import com.rjconsultores.ventaboletos.relatorios.utilitarios.Relatorio;
import com.rjconsultores.ventaboletos.relatorios.utilitarios.RelatorioBilhetesVendidosNovoLayoutBean;
import com.rjconsultores.ventaboletos.utilerias.DateUtil;
import com.rjconsultores.ventaboletos.web.utilerias.NamedParameterStatement;

import net.sf.jasperreports.engine.data.JRBeanCollectionDataSource;

/**
 * @author Wallace
 *
 */
public class RelatorioBilhetesVendidosNovoLayout extends Relatorio {

	public RelatorioBilhetesVendidosNovoLayout(Map<String, Object> parametros, Connection conexao) throws Exception {
		super(parametros, conexao);
	}

	private List<RelatorioBilhetesVendidosNovoLayoutBean> lsDadosRelatorio;

	@Override
	protected void processaParametros() throws Exception {

		this.setCustomDataSource(new ArrayDataSource(this) {
			@Override
			public void initDados() throws Exception {

				Connection conexao = this.relatorio.getConexao();
				Map<String, Object> parametros = this.relatorio.getParametros();

				StringBuilder sql = new StringBuilder();
				sql.append("select t.cveestado,");
				sql.append("       t.datavenda,");
				sql.append("       t.statuspassagem,");
				sql.append("       t.especie,");
				sql.append("       t.forminicial,");
				sql.append("       t.formfinal,");
				sql.append("       t.serie,");
				sql.append("       t.preciopagado as valorcontabil,");
				sql.append("       t.preciopagado - (t.preciopagado * coalesce(t.porcredbaseicms / 100,0))as valorbasecalculo,");
				sql.append("       t.valoraliquiotaicms,");
				sql.append("       ((t.preciopagado - (t.preciopagado * coalesce(t.porcredbaseicms / 100,0))) * t.icms) / 100 as valoricms ");
				sql.append("from");
				sql.append("  (select distinct est.icms,");
				sql.append("                   est.cveestado as cveestado,");
				sql.append("                   ei.porcredbaseicms,");
				sql.append("                   c.fechorventa as datavenda,");
				sql.append("                   c.indstatusboleto statuspassagem,");
				sql.append("                   ae.decespecie as especie,");
				sql.append("     (select min(numfoliosistema) as maximo");
				sql.append("      from boleto e");
				sql.append("      where e.numoperacion = c.numoperacion) as forminicial,");
				sql.append("     (select max(numfoliosistema) as maximo");
				sql.append("      from boleto e");
				sql.append("      where e.numoperacion = c.numoperacion) as formfinal,");
				sql.append("                   c.numseriepreimpresa as serie,");
				sql.append("                   c.preciopagado as valorcontabil,");
				sql.append("                   est.icms as valoraliquiotaicms,");
				sql.append("     (select sum(c.preciopagado) as preciopagado");
				sql.append("      from caja e");
				sql.append("      where e.numoperacion = c.numoperacion and e.fechorventa between :DATA_INICIAL AND :DATA_FINAL ) as preciopagado");
				sql.append("   from caja c");
				sql.append("   left join aidf a on a.aidf_id = c.aidf_id");
				sql.append("   left join aidf_especie ae on (a.aidfesp_id = ae.aidfesp_id)");
				sql.append("   join empresa e on e.empresa_id = c.empresacorrida_id");
				sql.append("   join parada po on po.parada_id = c.origen_id");
				sql.append("   join ciudad co on co.ciudad_id = po.ciudad_id");
				sql.append("   join estado est on est.estado_id = co.estado_id");
				sql.append("   join empresa_imposto ei on ei.empresa_id = e.empresa_id");
				sql.append("   join punto_venta pv on c.puntoventa_id = pv.puntoventa_id");
				sql.append("   and ei.estado_id = est.estado_id");
				sql.append(" where ");
				sql.append(" c.empresacorrida_id = :EMPRESA_ID ");
				sql.append(" and c.fechorventa between :DATA_INICIAL AND :DATA_FINAL  ");
				sql.append(" and c.activo = 1");
				sql.append(" and ei.activo = 1");
				if (parametros.get("NUMPUNTOVENTA") != null && !parametros.get("NUMPUNTOVENTA").equals("-1")) {
					sql.append(" and pv.PUNTOVENTA_ID IN (" + parametros.get("NUMPUNTOVENTA").toString() + ")");
				}
				if (parametros.get("ESTADO_ID") != null && !parametros.get("ESTADO_ID").equals("-1")) {
					sql.append(" and est.estado_id = " + parametros.get("ESTADO_ID").toString() + "");
				}
				if (parametros.get("STATUS") != null) {
					if (parametros.get("STATUS").toString().contains("V") && parametros.get("STATUS").toString().contains("C")) {
						sql.append(" and ((c.INDSTATUSBOLETO   = 'C' AND c.MOTIVOCANCELACION_ID IS NOT NULL) OR (c.INDSTATUSBOLETO = 'V' AND c.MOTIVOCANCELACION_ID IS NULL)) ");
					} else if (parametros.get("STATUS").toString().contains("C")) {
						sql.append(" and c.INDSTATUSBOLETO   = 'C' AND c.MOTIVOCANCELACION_ID IS NOT NULL ");
					} else if (parametros.get("STATUS").toString().contains("V")) {
						sql.append(" and c.INDSTATUSBOLETO   = 'V' AND c.MOTIVOCANCELACION_ID IS NULL ");
					}
				}
				sql.append(") t ");
				sql.append("order by t.cveestado, t.datavenda ");
				
				NamedParameterStatement stmt = new NamedParameterStatement(conexao, sql.toString());

				stmt.setInt("EMPRESA_ID", Integer.valueOf(parametros.get("EMPRESA_ID").toString()));
				stmt.setDate("DATA_INICIAL", new java.sql.Date(DateUtil.inicioFecha((Date) parametros.get("DATA_INICIAL")).getTime()));
				stmt.setDate("DATA_FINAL", new java.sql.Date(DateUtil.fimFecha((Date) parametros.get("DATA_FINAL")).getTime()));

				ResultSet rset = stmt.executeQuery();
				lsDadosRelatorio = new ArrayList<RelatorioBilhetesVendidosNovoLayoutBean>();
				DecimalFormat df = new DecimalFormat("0.00");  
				df.setMaximumFractionDigits(2);
				df.setRoundingMode(RoundingMode.DOWN);
				
				while (rset.next()) {

					RelatorioBilhetesVendidosNovoLayoutBean bean = new RelatorioBilhetesVendidosNovoLayoutBean();

					Map<String, Object> dataResult = new HashMap<String, Object>();

					if (rset.getString("SERIE") != null) {
						if (rset.getString("SERIE").split("-").length == 1) {
							dataResult.put("SERIE", rset.getString("SERIE"));
						} else {
							dataResult.put("SERIE", rset.getString("SERIE").split("-")[0]);
							dataResult.put("SUB_SERIE", rset.getString("SERIE").split("-")[1]);
						}
					}

					if (rset.getString("statuspassagem") != null) {
						dataResult.put("statuspassagem", IndStatusBoleto.valueOf(rset.getString("statuspassagem")).getValue());
					}
					bean.setDataVenda(rset.getTimestamp("datavenda") != null ? DateUtil.getStringDate(rset.getTimestamp("datavenda"), "dd/MM/yyyy HH:mm") : "");	
					bean.setFormInicial((String) (rset.getObject("formInicial") == null ? "" : rset.getObject("formInicial")));
					bean.setFormFinal((String) (rset.getObject("formfinal") == null ? "" : rset.getObject("formfinal")));
					bean.setSerie((String) (rset.getObject("serie") == null ? "" : rset.getObject("serie")));
					bean.setValorContabil(rset.getObject("valorcontabil") == null ? "" : df.format(rset.getFloat("valorcontabil")));
					bean.setValorBaseCalculo(rset.getObject("valorbasecalculo") == null ? "" : df.format(rset.getFloat("valorbasecalculo")));
					bean.setValorAliquiotaICMS(rset.getObject("valoraliquiotaicms") == null ? "" :  df.format(rset.getFloat("valoraliquiotaicms")));
					bean.setValorICMS(rset.getObject("valoricms") == null ? "" :  df.format(rset.getDouble("valoricms")));
					bean.setUf((String) (rset.getObject("cveestado") == null ? "" : rset.getObject("cveestado")));
					bean.setStatusPassagem((String) (rset.getObject("statuspassagem") != null && rset.getObject("statuspassagem").equals("V") ? "N" : rset.getString("statuspassagem")));
					bean.setEspecie((String) (rset.getObject("especie") == null ? "" : rset.getObject("especie")));
					bean.setCodFiscal("5357"); // cdigo fixo indicado pelo cliente mantis 10516

					lsDadosRelatorio.add(bean);

				}

				if (lsDadosRelatorio.size() > 0) {
					setLsDadosRelatorio(lsDadosRelatorio);
				}
			}
		});
	}

	public void setLsDadosRelatorio(List<RelatorioBilhetesVendidosNovoLayoutBean> lsDadosRelatorio) {
		this.setCollectionDataSource(new JRBeanCollectionDataSource(lsDadosRelatorio));
		this.lsDadosRelatorio = lsDadosRelatorio;
	}

}
